// Jason Rohrer
// ZPixel.h

/**
*
*	ZPixle object for RadiosGL
*
*	a Z-buffer pixel:  contains Z value and object ID
*
*
*	Created 9-12-99
*	Mods:
*
*/



#ifndef ZPIXEL_INCLUDED
#define ZPIXEL_INCLUDED

#include <float.h>

class ZPixel {
	
	public:
		
		
		// center of top, Normal of top, pointer to hemicube
		ZPixel();
		
		int getObjectID();
		float getZValue();
		char getIsBack();
		
		void add(int oID, float z, char back);		// add into this Z pixel with comparisson to current value
		
	private :
	
		int objectID;
		float zValue;
		char isBack;		// is the back side of this patch facing the z buffer
		// back info is used to tell when an object may be blocking other objects
		// in the buffer, but not contributing light (or whatever) to image
	};







inline ZPixel::ZPixel() {
	objectID = -1;
	zValue = +FLT_MAX;
	isBack = true;
	}	

inline void ZPixel::add(int oID, float z, char back) {
	if( zValue > z ) {
		zValue = z;
		objectID = oID;
		isBack = back;
		}
	}

inline int ZPixel::getObjectID() {
	return objectID;
	}
	
inline float ZPixel::getZValue() {
	return zValue;
	}
	
inline char ZPixel::getIsBack() {
	return isBack;
	}	
	
#endif