// Jason Rohrer
// zBufferPatch.h

/**
*
*	function for z-buffering a patch onto a viewplane
*
*
*
*	Created 9-24-99
*	Mods:
*
*/


// Z-buffer patch onto viewplane
// Assumes that plane perp to z-axis, facing z+ dir
// params:
//		pID					= patchID to go into Z-buffer
//		planePixWide 		= view plane pixels wide
//		planeStartX 		= minX of view plane in world coords
//		planeStartY 		= minY of view plane in world coords
// 		d					= distance of viewplane from projection point


#ifndef ZBUFFERPATCH_INCLUDED
#define ZBUFFERPATCH_INCLUDED

#include "ZPixel.h"
#include "Patch.h"

void zBufferPatch( ZPixel *viewPlane, int *yOffset, Patch *p, int pID,
						int planePixWide, int planePixHigh,
						float planeStartX, float planeEndX, 
						float planeStartY, float planeEndY,
						float d);
						
						
						
						
#endif